/* This file was generated by Contract AspectJ v0.1 on Sat Nov 06 14:12:10 EST 2004 */
package jsim.queue;


public class PriorityQueue extends Queue{
	protected PQ_Node root;
	
	public PriorityQueue(){
		root=null;
		
	}
	
	public PriorityQueue(int capacity){
		root=null;
		this.capacity=capacity;
		
	}
	
	public void printQueue(){
		printTree(root);
		
	}
	private int level=0;
	
	private void printTree(PQ_Node node){
		level++;
		if(node!=null){
			for(int i=0;i<level;i++){
				System.out.print("  ");
				
			}
			;
			System.out.println("[ . "+node.priority+" . ]");
			printTree(node.left);
			printTree((PQ_Node)node.right);
			
		}
		;
		level--;
		
	}
	
	public Q_Node enqueue(Object item){
		/* @pre{this.size<this.capacity} */
		return enqueue(item,Thread.NORM_PRIORITY);
		
	}
	
	public Q_Node enqueue(Object item,int priority){
		/* @pre{this.size<this.capacity} */
		PQ_Node newNode=new PQ_Node(item,priority);
		if(root!=null){
			splayForInsert(newNode);
			if(newNode.compare(root)<0){
				newNode.left=root.left;
				newNode.right=root;
				root.left=null;
				
			}
			else{
				newNode.left=root;
				newNode.right=root.right;
				root.right=null;
				
			}
			;
			
		}
		;
		size++;
		return root=newNode;
		
	}
	
	protected PQ_Node splayLeft(PQ_Node node,PQ_Node lChild){
		/* @pre{lChild!=null} */
		node.left=(PQ_Node)lChild.right;
		lChild.right=node;
		return lChild;
		
	}
	
	protected PQ_Node splayRight(PQ_Node node,PQ_Node rChild){
		/* @pre{rChild!=null} */
		node.right=rChild.left;
		rChild.left=node;
		return rChild;
		
	}
	
	protected void splayForInsert(PQ_Node newNode){
		/* @pre{newNode!=null} */
		PQ_Node lChild;
		PQ_Node rChild;
		for(;;){
			if(newNode.compare(root)<0){
				if((lChild=root.left)==null)break;
				if(newNode.compare(lChild)<0){
					root=splayLeft(root,lChild);
					
				}
				else{
					if(lChild.right==null)break;
					lChild=splayRight(lChild,(PQ_Node)lChild.right);
					
				}
				
			}
			else if(newNode.compare(root)>=0){
				if((rChild=(PQ_Node)root.right)==null)break;
				if(newNode.compare(rChild)>0){
					root=splayRight(root,rChild);
					
				}
				else{
					if(rChild.left==null)break;
					lChild=splayLeft(rChild,rChild.left);
					
				}
				
			}
			
		}
		
	}
	
	public Q_Node dequeue(){
		/* @pre{root!=null} */
		PQ_Node first=null;
		for(boolean done=false;!done;){
			first=getMin();
			done=first.present;
			root=(PQ_Node)root.right;
			size--;
			
		}
		return first;
		
	}
	
	protected PQ_Node getMin(){
		/* @pre{root!=null} */
		for(PQ_Node lChild=null;(lChild=root.left)!=null;){
			root=splayLeft(root,lChild);
			
		}
		return root;
		
	}
	
}
